
/* ##############################################################
	설  명 : [Modal]공지사항 등록 팝업
	작성일 : 2023. 01. 19.
	작성자 : NTsoft
	수정일 	        수정자 	 수정내용
	-------         -------- ---------------------------
	2023. 01. 19.	NTsoft 	 최초 생성
*/
let noticeInsertModal = {
	callback : null,
	reqParam : null,
	dataList : null,
	/* 모달 초기화 작업 */
	init : function () {
		$('#noticeInsertModal').remove();
		$('body').append( this.HtmlTemplate);
		//그리드 이벤트
		this.setEvent();
	},
	/* 그리드 이벤트 설정 */
	setEvent:function() {
		$('#noticeInsertModal .btnCancle').on("click", function(){
			noticeInsertModal.close();
		});
		
		$('#noticeInsertModal .btnSave').on("click", function(){
			noticeInsertModal.save("I");
		});
		
		$("#noticeInsertModal #modalOpenDate").datetimepicker({
			allowInputToggle: true,
			format: 'YYYY-MM-DD',
			defaultDate: moment()
		});
	},
	/* 데이터 선택 */
	setSelect:function(selectNumber) {
		let checkedData = dataList[selectNumber];
		if(dataList==null||checkedData==undefined){
			return ;
		}
		
		if( noticeInsertModal.callback )  {
			noticeInsertModal.callback(checkedData);
		}
		noticeInsertModal.close();
	},
	//저장
	save:function(state) {
		let title     = $("#noticeInsertModal #modalTitle").val();
		let content   = $("#noticeInsertModal #modalContent").val();
		let openDate  = $("#noticeInsertModal #modalOpenDate").val();
		let openTime  = $("#noticeInsertModal #modalOpenTime").val();
		
		if(true != fn_emptyCheck(title)){
			modalEvent.warning("등록", "제목 정보가 없습니다.");	
			return;
		}
		else{
			if(true != fn_lengthCheck(title, 100)) {
				modalEvent.warning("등록", "제목 정보는 100자를 넘을 수 없습니다.");	
				return;
			}
		}
		
		if(true != fn_emptyCheck(content)){
			modalEvent.warning("등록", "내용 정보가 없습니다.");	
			return;
		}
		
		if(true != fn_emptyCheck(openDate)){
			modalEvent.warning("등록", "게시일 정보가 없습니다.");	
			return;
		}
		
		if(true != fn_emptyCheck(openTime)){
			modalEvent.warning("등록", "게시시간 정보가 없습니다.");	
			return;
		}
		
		modalEvent.info("등록", "공지사항 정보를 등록하시겠습니까?", function(){
			let formData = new FormData();
			formData.append("menuClass", menuClass);
			formData.append("title", title);
			formData.append("content", content);
			formData.append("openDate", openDate);
			formData.append("openTime", openTime);
	
			$.ajax({
				url: encodeURI('/webnotice/insertNotice.do'),
				data: formData,
				dataType: "json",
				processData: false,
				contentType: false,
				type: 'POST',
				async: true,
				success: function(data){
					if('0'==data.msgCode){
						modalEvent.success("등록 성공", data.msgDesc, function(){
							if( noticeInsertModal.callback )  {
								noticeInsertModal.callback();
							}
							noticeInsertModal.close();
						});
					}
					else{
						modalEvent.danger("등록 오류", data.msgDesc);
					}
				},
				error : function(xhr, status, error) {
					modalEvent.danger("등록 오류", "등록 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
				},
				beforeSend:function(){
					
				},
				complete:function(){
					
				}
			});
		});
	},
	/*
	 * 팝업
	 * callback : 콜백함수, reqParam: 팝업파라미터
	 */
	popup:function(callback, reqParam) {
		// 초기화 후 열기
		noticeInsertModal.init();
		
		//콜백함수 지정.
		noticeInsertModal.callback = callback;
		noticeInsertModal.reqParam = reqParam;
		noticeInsertModal.dataList = null;
		
		setTimeout(function(){
			$('#noticeInsertModal').modal('show')
		}, 200);
	},
	/*
	 * 팝업 닫기
	 */
	close:function() {
		$('#noticeInsertModal').modal('hide');

		setTimeout(function(){
			$('#noticeInsertModal').remove();
		},500);
	},
	HtmlTemplate : `
	<div id="noticeInsertModal" class="modal notice_registration_modal fade" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="">
		<div class="modal-dialog">
			<div class="modal-content">
				<div class="modal-header">
					<p class="title">공지사항 등록</p>
				</div>
	
				<div class="modal-body">
					<div class="form_box">
						<div class="input_box">
							<label>제목</label>
							<input type="text" id="modalTitle" placeholder="제목 입력" maxlength="100">
						</div>

						<div class="textarea_box">
							<label>내용</label>
							<textarea id="modalContent" placeholder="내용을 입력해주세요."></textarea>
						</div>

						<div class="registration_box">
							<label>게시일</label>

							<div class="date_box">
								<img src="/image/web/calendar.svg" alt="calendar"/>
								<input type="date" class="date_picker" id="modalOpenDate">
							</div>

							<input type="text" id="modalOpenTime" placeholder="00:00" maxlength="5">
						</div>
					</div>
				</div>

				<div class="modal-footer">
					<div class="btn_box">
						<button type="button" class="cancel_btn btnCancle">취소</button>
						<button type="button" class="save_bth btnSave">저장</button>
					</div>
				</div>
			</div>
		</div>
	</div>
    `
};